Clazz.declarePackage ("jalview.analysis.scoremodels");
Clazz.load (["jalview.api.analysis.ScoreModelI"], "jalview.analysis.scoremodels.SWScoreModel", ["jalview.analysis.AlignSeq", "jalview.util.Comparison"], function () {
c$ = Clazz.declareType (jalview.analysis.scoremodels, "SWScoreModel", null, jalview.api.analysis.ScoreModelI);
Clazz.overrideMethod (c$, "findDistances", 
function (seqData) {
var sequenceString = seqData.getVisibleAlignment (jalview.util.Comparison.GapChars.charAt (0)).getSequencesArray ();
var noseqs = sequenceString.length;
var distance =  Clazz.newFloatArray (noseqs, noseqs, 0);
var max = -1;
for (var i = 0; i < (noseqs - 1); i++) {
for (var j = i; j < noseqs; j++) {
var as =  new jalview.analysis.AlignSeq (sequenceString[i], sequenceString[j], seqData.isNa () ? "dna" : "pep");
as.calcScoreMatrix ();
as.traceAlignment ();
as.printAlignment (System.out);
distance[i][j] = as.maxscore;
if (max < distance[i][j]) {
max = distance[i][j];
}}
}
for (var i = 0; i < (noseqs - 1); i++) {
for (var j = i; j < noseqs; j++) {
distance[i][j] = max - distance[i][j];
distance[j][i] = distance[i][j];
}
}
return distance;
}, "jalview.datamodel.AlignmentView");
Clazz.overrideMethod (c$, "getName", 
function () {
return "Smith Waterman Score";
});
Clazz.overrideMethod (c$, "isDNA", 
function () {
return true;
});
Clazz.overrideMethod (c$, "isProtein", 
function () {
return true;
});
Clazz.overrideMethod (c$, "toString", 
function () {
return "Score between two sequences aligned with Smith Waterman with default Peptide/Nucleotide matrix";
});
});
