Clazz.declarePackage ("jalview.javascript");
Clazz.load (null, "jalview.javascript.JSFunctionExec", ["jalview.bin.JalviewLite", "java.lang.StringBuffer", "$.Thread", "java.net.MalformedURLException", "$.URL", "netscape.javascript.JSException", "$.JSObject"], function () {
c$ = Clazz.decorateAsClass (function () {
this.jvlite = null;
this.jsExecQueue = null;
this.executor = null;
Clazz.instantialize (this, arguments);
}, jalview.javascript, "JSFunctionExec", null, Runnable);
Clazz.makeConstructor (c$, 
function (applet) {
this.jvlite = applet;
this.jsExecQueue = this.jvlite.getJsExecQueue ();
this.jvlite.setExecutor (this);
}, "jalview.bin.JalviewLite");
Clazz.overrideMethod (c$, "finalize", 
function () {
this.jvlite = null;
this.executor = null;
if (this.jsExecQueue != null) {
this.jsExecQueue.clear ();
}this.jsExecQueue = null;
});
Clazz.defineMethod (c$, "stopQueue", 
function () {
if (this.jsExecQueue != null) {
var q = null;
{
q = this.jsExecQueue;
this.jsExecQueue = null;
}if (q != null) {
for (var jx, $jx = q.iterator (); $jx.hasNext () && ((jx = $jx.next ()) || true);) {
jx.jvlite = null;
}
q.removeAllElements ();
{
q.notifyAll ();
}}}this.jvlite = null;
this.executor = null;
});
Clazz.defineMethod (c$, "run", 
function () {
while (this.jsExecQueue != null) {
if (this.jsExecQueue.size () > 0) {
var r = this.jsExecQueue.elementAt (0);
this.jsExecQueue.removeElementAt (0);
try {
r.run ();
} catch (e$$) {
if (Clazz.exceptionOf (e$$, Exception)) {
var ex = e$$;
{
ex.printStackTrace ();
}
} else if (Clazz.exceptionOf (e$$, Error)) {
var ex = e$$;
{
ex.printStackTrace ();
}
} else {
throw e$$;
}
}
} else {
try {
{
this.jsExecQueue.wait (1000);
}} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
} else {
throw ex;
}
}
;}}
});
Clazz.defineMethod (c$, "executeJavascriptFunction", 
function (_listener, objects) {
this.executeJavascriptFunction (false, _listener, objects);
}, "~S,~A");
Clazz.defineMethod (c$, "executeJavascriptFunction", 
function (async, _listener, $arguments) {
this.executeJavascriptFunction (async, _listener, $arguments, null);
}, "~B,~S,~A");
Clazz.defineMethod (c$, "executeJavascriptFunction", 
function (async, _listener, $arguments, dbgMsg) {
var objects =  new Array ($arguments != null ? $arguments.length : 0);
if ($arguments != null) {
System.arraycopy ($arguments, 0, objects, 0, $arguments.length);
}var jsex =  new Array (1);
var exec = ((Clazz.isClassDefined ("jalview.javascript.JSFunctionExec$1") ? 0 : jalview.javascript.JSFunctionExec.$JSFunctionExec$1$ ()), Clazz.innerTypeInstance (jalview.javascript.JSFunctionExec$1, this, Clazz.cloneFinals ("dbgMsg", dbgMsg, "_listener", _listener, "objects", objects, "jsex", jsex, "async", async)));
if (async) {
if (this.executor == null) {
this.executor =  new Thread ( new jalview.javascript.JSFunctionExec (this.jvlite));
this.executor.start ();
}{
this.jsExecQueue.addElement (exec);
this.jsExecQueue.notify ();
}} else {
exec.run ();
if (jsex[0] != null) {
throw (jsex[0]);
}}}, "~B,~S,~A,~S");
c$.$JSFunctionExec$1$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.javascript, "JSFunctionExec$1", null, Runnable);
Clazz.defineMethod (c$, "run", 
function () {
try {
var scriptObject = null;
try {
scriptObject = netscape.javascript.JSObject.getWindow (this.b$["jalview.javascript.JSFunctionExec"].jvlite);
} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
} else {
throw ex;
}
}
;if (scriptObject != null) {
if (jalview.bin.JalviewLite.debug && this.f$.dbgMsg != null) {
System.err.println (this.f$.dbgMsg);
}scriptObject.call (this.f$._listener, this.f$.objects);
}} catch (jex) {
if (Clazz.exceptionOf (jex, Exception)) {
if (!(Clazz.instanceOf (jex, java.net.MalformedURLException))) {
if (jalview.bin.JalviewLite.debug) {
System.err.println (jex);
}if (Clazz.instanceOf (jex, netscape.javascript.JSException) && this.b$["jalview.javascript.JSFunctionExec"].jvlite.jsfallbackEnabled) {
this.f$.jsex[0] = jex;
if (jalview.bin.JalviewLite.debug) {
System.err.println ("Falling back to javascript: url call");
}var sb =  new StringBuffer ("javascript:" + this.f$._listener + "(");
for (var i = 0; this.f$.objects != null && i < this.f$.objects.length; i++) {
if (i > 0) {
sb.append (",");
}sb.append ("\"");
if (this.f$.objects[i] != null && !(this.f$.objects[i].getClass ().getName ().indexOf ("jalview") == 0)) {
sb.append (this.f$.objects[i].toString ());
}sb.append ("\"");
}
sb.append (")");
if (jalview.bin.JalviewLite.debug) {
System.err.println (sb.toString ());
}var url = null;
try {
url =  new java.net.URL (sb.toString ());
this.b$["jalview.javascript.JSFunctionExec"].jvlite.getAppletContext ().showDocument (url);
jex = null;
} catch (uex) {
if (Clazz.exceptionOf (uex, Exception)) {
jex = uex;
} else {
throw uex;
}
}
}if (jex != null) {
if (this.f$.async) {
jex.printStackTrace ();
} else {
this.f$.jsex[0] = jex;
}};}} else {
throw jex;
}
}
});
c$ = Clazz.p0p ();
};
});
